<h1>
code-edit <a href="https://npmjs.org/package/code-edit"><img src="https://img.shields.io/badge/npm-v4.1.0-F00.svg?colorA=000"/></a> <a href="src"><img src="https://img.shields.io/badge/loc-460-FFF.svg?colorA=000"/></a> <a href="https://cdn.jsdelivr.net/npm/code-edit@4.1.0/dist/code-edit.min.js"><img src="https://img.shields.io/badge/brotli-24K-333.svg?colorA=000"/></a> <a href="LICENSE"><img src="https://img.shields.io/badge/license-MIT-F0B.svg?colorA=000"/></a>
</h1>

<p></p>

Lightweight code editor Web Component with syntax highlighting

<h4>
<table><tr><td title="Triple click to select and copy paste">
<code>npm i code-edit </code>
</td><td title="Triple click to select and copy paste">
<code>pnpm add code-edit </code>
</td><td title="Triple click to select and copy paste">
<code>yarn add code-edit</code>
</td></tr></table>
</h4>

## Examples

<details id="example$web" title="web" open><summary><span><a href="#example$web">#</a></span>  <code><strong>web</strong></code></summary>  <ul>    <details id="source$web" title="web source code" ><summary><span><a href="#source$web">#</a></span>  <code><strong>view source</strong></code></summary>  <a href="example/web.ts">example/web.ts</a>  <p>

```ts
import 'code-syntax/themes/default.css'
import 'plenty-themes/laser.css'

import { CodeEditElement, languages } from 'code-edit'

languages.js = import('code-syntax/languages/js.js')
customElements.define('code-edit', CodeEditElement)

const style = document.createElement('style')
style.textContent = /*css*/ `
html,
body {
  margin: 0;
  padding: 0;
  width: 100%;
  height: 100%;
}
body {
  background: #333;
}
pre {
  color: var(--color);
  background: var(--background);
}
code-edit {
  margin: 15px;
  padding: 15px;
  width: 300px;
  height: 100px;
  font-family: monospace;
  resize: both;
}
`
document.head.appendChild(style)

document.body.innerHTML = /*html*/ `
<code-edit id="demo" autoresize autofocus language="js" theme="laser">export interface HTMLCodeEditElement {
  value?: string
  language?: string
  syntax?: SyntaxDefinition | Promise&lt;{ default: SyntaxDefinition }&gt;
  theme?: string
  tabsize?: number
  tabstyle?: 'tabs' | 'spaces'
  comments?: string
}</code-edit>
`
```

</p>
</details></ul></details>

## API

<p>  <details id="CodeEditElement$31" title="Class" ><summary><span><a href="#CodeEditElement$31">#</a></span>  <code><strong>CodeEditElement</strong></code>    </summary>  <a href="src/code-edit.tsx#L172">src/code-edit.tsx#L172</a>  <ul>        <p>  <details id="constructor$32" title="Constructor" ><summary><span><a href="#constructor$32">#</a></span>  <code><strong>constructor</strong></code><em>()</em>    </summary>  <a href="node_modules/typescript/lib/lib.dom.d.ts#L6370">node_modules/typescript/lib/lib.dom.d.ts#L6370</a>  <ul>    <p>  <details id="new CodeEditElement$33" title="ConstructorSignature" ><summary><span><a href="#new CodeEditElement$33">#</a></span>  <code><strong>new CodeEditElement</strong></code><em>()</em>    </summary>    <ul><p><a href="#CodeEditElement$31">CodeEditElement</a></p>        </ul></details></p>    </ul></details><details id="$$126" title="Property" ><summary><span><a href="#$$126">#</a></span>  <code><strong>$</strong></code>    </summary>  <a href=""></a>  <ul><p><span>Context</span>&lt;<a href="#CodeEditElement$31">CodeEditElement</a> &amp; <span>JsxContext</span>&lt;<a href="#CodeEditElement$31">CodeEditElement</a>&gt; &amp; <span>Omit</span>&lt;{<p>    <details id="ctor$130" title="Parameter" ><summary><span><a href="#ctor$130">#</a></span>  <code><strong>ctor</strong></code>    </summary>    <ul><p><span>Class</span>&lt;<a href="#T$90">T</a>&gt;</p>        </ul></details>  <p><strong></strong>&lt;<span>T</span>&gt;<em>(ctor)</em>  &nbsp;=&gt;  <ul><span>CleanClass</span>&lt;<a href="#T$90">T</a>&gt;</ul></p>  <details id="ctx$145" title="Parameter" ><summary><span><a href="#ctx$145">#</a></span>  <code><strong>ctx</strong></code>    </summary>    <ul><p><a href="#T$105">T</a> | <span>Class</span>&lt;<a href="#T$105">T</a>&gt;</p>        </ul></details>  <p><strong></strong>&lt;<span>T</span>&gt;<em>(ctx)</em>  &nbsp;=&gt;  <ul><span>Wrapper</span>&lt;<a href="#T$105">T</a>&gt;</ul></p></p>} &amp; <span>__module</span> &amp; {<p>  <details id="Boolean$149" title="Property" ><summary><span><a href="#Boolean$149">#</a></span>  <code><strong>Boolean</strong></code>    </summary>  <a href=""></a>  <ul><p>undefined | boolean</p>        </ul></details><details id="Number$148" title="Property" ><summary><span><a href="#Number$148">#</a></span>  <code><strong>Number</strong></code>    </summary>  <a href=""></a>  <ul><p>undefined | number</p>        </ul></details><details id="String$147" title="Property" ><summary><span><a href="#String$147">#</a></span>  <code><strong>String</strong></code>    </summary>  <a href=""></a>  <ul><p>undefined | string</p>        </ul></details></p>}, <code>"transition"</code>&gt;&gt;</p>        </ul></details><details id="CodeSyntax$45" title="Property" ><summary><span><a href="#CodeSyntax$45">#</a></span>  <code><strong>CodeSyntax</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>...</code></span>  </summary>  <a href="src/code-edit.tsx#L211">src/code-edit.tsx#L211</a>  <ul><p><span>Component</span>&lt;<span>CodeSyntaxElement</span>, <span>HTMLElement</span>&gt;</p>        </ul></details><details id="SuperImpose$46" title="Property" ><summary><span><a href="#SuperImpose$46">#</a></span>  <code><strong>SuperImpose</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>...</code></span>  </summary>  <a href="src/code-edit.tsx#L212">src/code-edit.tsx#L212</a>  <ul><p><span>Component</span>&lt;<span>SuperImposeElement</span>, <span>HTMLElement</span>&gt;</p>        </ul></details><details id="TextAreaCode$47" title="Property" ><summary><span><a href="#TextAreaCode$47">#</a></span>  <code><strong>TextAreaCode</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>...</code></span>  </summary>  <a href="src/code-edit.tsx#L213">src/code-edit.tsx#L213</a>  <ul><p><span>Component</span>&lt;<span>TextAreaCodeElement</span>, <span>HTMLElement</span>&gt;</p>        </ul></details><details id="TextShadow$48" title="Property" ><summary><span><a href="#TextShadow$48">#</a></span>  <code><strong>TextShadow</strong></code>    </summary>  <a href="src/code-edit.tsx#L215">src/code-edit.tsx#L215</a>  <ul><p><details id="__type$49" title="Function" ><summary><span><a href="#__type$49">#</a></span>  <em>({ x, y })</em>    </summary>    <ul>    <p>    <details id="props$51" title="Parameter" ><summary><span><a href="#props$51">#</a></span>  <code><strong>props</strong></code>    </summary>    <ul><p>{<p>  <details id="x$53" title="Property" ><summary><span><a href="#x$53">#</a></span>  <code><strong>x</strong></code>    </summary>  <a href="src/code-edit.tsx#L215">src/code-edit.tsx#L215</a>  <ul><p>number</p>        </ul></details><details id="y$54" title="Property" ><summary><span><a href="#y$54">#</a></span>  <code><strong>y</strong></code>    </summary>  <a href="src/code-edit.tsx#L215">src/code-edit.tsx#L215</a>  <ul><p>number</p>        </ul></details></p>}</p>        </ul></details>  <p><strong></strong><em>({ x, y })</em>  &nbsp;=&gt;  <ul><span>VKid</span></ul></p></p>    </ul></details></p>        </ul></details><details id="autoFocus$36" title="Property" ><summary><span><a href="#autoFocus$36">#</a></span>  <code><strong>autoFocus</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>false</code></span>  </summary>  <a href="src/code-edit.tsx#L193">src/code-edit.tsx#L193</a>  <ul><p>boolean</p>        </ul></details><details id="autoResize$37" title="Property" ><summary><span><a href="#autoResize$37">#</a></span>  <code><strong>autoResize</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>false</code></span>  </summary>  <a href="src/code-edit.tsx#L195">src/code-edit.tsx#L195</a>  <ul><p>boolean</p>        </ul></details><details id="caretBlink$80" title="Property" ><summary><span><a href="#caretBlink$80">#</a></span>  <code><strong>caretBlink</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>'none'</code></span>  </summary>  <a href="src/code-edit.tsx#L263">src/code-edit.tsx#L263</a>  <ul><p><code>"blink"</code> | <code>"none"</code></p>        </ul></details><details id="caretBlinkTimeout$81" title="Property" ><summary><span><a href="#caretBlinkTimeout$81">#</a></span>  <code><strong>caretBlinkTimeout</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>-1</code></span>  </summary>  <a href="src/code-edit.tsx#L264">src/code-edit.tsx#L264</a>  <ul><p>any</p>        </ul></details><details id="caretIndex$78" title="Property" ><summary><span><a href="#caretIndex$78">#</a></span>  <code><strong>caretIndex</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>0</code></span>  </summary>  <a href="src/code-edit.tsx#L261">src/code-edit.tsx#L261</a>  <ul><p>number</p>        </ul></details><details id="caretShift$79" title="Property" ><summary><span><a href="#caretShift$79">#</a></span>  <code><strong>caretShift</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>'none'</code></span>  </summary>  <a href="src/code-edit.tsx#L262">src/code-edit.tsx#L262</a>  <ul><p><code>"forward"</code> | <code>"backward"</code> | <code>"none"</code></p>        </ul></details><details id="comments$42" title="Property" ><summary><span><a href="#comments$42">#</a></span>  <code><strong>comments</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>'// /* */'</code></span>  </summary>  <a href="src/code-edit.tsx#L205">src/code-edit.tsx#L205</a>  <ul><p>string</p>        </ul></details><details id="context$150" title="Property" ><summary><span><a href="#context$150">#</a></span>  <code><strong>context</strong></code>    </summary>  <a href=""></a>  <ul><p><span>ContextClass</span>&lt;<a href="#CodeEditElement$31">CodeEditElement</a> &amp; <span>JsxContext</span>&lt;<a href="#CodeEditElement$31">CodeEditElement</a>&gt; &amp; <span>Omit</span>&lt;{<p>    <details id="ctor$154" title="Parameter" ><summary><span><a href="#ctor$154">#</a></span>  <code><strong>ctor</strong></code>    </summary>    <ul><p><span>Class</span>&lt;<a href="#T$90">T</a>&gt;</p>        </ul></details>  <p><strong></strong>&lt;<span>T</span>&gt;<em>(ctor)</em>  &nbsp;=&gt;  <ul><span>CleanClass</span>&lt;<a href="#T$90">T</a>&gt;</ul></p>  <details id="ctx$169" title="Parameter" ><summary><span><a href="#ctx$169">#</a></span>  <code><strong>ctx</strong></code>    </summary>    <ul><p><a href="#T$105">T</a> | <span>Class</span>&lt;<a href="#T$105">T</a>&gt;</p>        </ul></details>  <p><strong></strong>&lt;<span>T</span>&gt;<em>(ctx)</em>  &nbsp;=&gt;  <ul><span>Wrapper</span>&lt;<a href="#T$105">T</a>&gt;</ul></p></p>} &amp; <span>__module</span> &amp; {<p>  <details id="Boolean$173" title="Property" ><summary><span><a href="#Boolean$173">#</a></span>  <code><strong>Boolean</strong></code>    </summary>  <a href=""></a>  <ul><p>undefined | boolean</p>        </ul></details><details id="Number$172" title="Property" ><summary><span><a href="#Number$172">#</a></span>  <code><strong>Number</strong></code>    </summary>  <a href=""></a>  <ul><p>undefined | number</p>        </ul></details><details id="String$171" title="Property" ><summary><span><a href="#String$171">#</a></span>  <code><strong>String</strong></code>    </summary>  <a href=""></a>  <ul><p>undefined | string</p>        </ul></details></p>}, <code>"transition"</code>&gt;&gt;</p>        </ul></details><details id="dispatch$111" title="Property" ><summary><span><a href="#dispatch$111">#</a></span>  <code><strong>dispatch</strong></code>    </summary>  <a href=""></a>  <ul><p><span>Dispatch</span>&lt;<details id="__type$112" title="Function" ><summary><span><a href="#__type$112">#</a></span>  <em>(name, detail, init)</em>    </summary>    <ul>    <p>    <details id="name$116" title="Parameter" ><summary><span><a href="#name$116">#</a></span>  <code><strong>name</strong></code>    </summary>    <ul><p><span>Event</span> | <span>Narrow</span>&lt;<a href="#K$114">K</a>, string&gt;</p>        </ul></details><details id="detail$117" title="Parameter" ><summary><span><a href="#detail$117">#</a></span>  <code><strong>detail</strong></code>    </summary>    <ul><p><a href="#E$115">E</a></p>        </ul></details><details id="init$118" title="Parameter" ><summary><span><a href="#init$118">#</a></span>  <code><strong>init</strong></code>    </summary>    <ul><p><span>CustomEventInit</span>&lt;any&gt;</p>        </ul></details>  <p><strong></strong>&lt;<span>K</span>, <span>E</span>&gt;<em>(name, detail, init)</em>  &nbsp;=&gt;  <ul>any</ul></p></p>    </ul></details>&gt;</p>        </ul></details><details id="fontSize$35" title="Property" ><summary><span><a href="#fontSize$35">#</a></span>  <code><strong>fontSize</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>9.5</code></span>  </summary>  <a href="src/code-edit.tsx#L191">src/code-edit.tsx#L191</a>  <ul><p>number</p>        </ul></details><details id="hasFocus$44" title="Property" ><summary><span><a href="#hasFocus$44">#</a></span>  <code><strong>hasFocus</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>false</code></span>  </summary>  <a href="src/code-edit.tsx#L209">src/code-edit.tsx#L209</a>  <ul><p>boolean</p>        </ul></details><details id="height$58" title="Property" ><summary><span><a href="#height$58">#</a></span>  <code><strong>height</strong></code>    </summary>  <a href="src/code-edit.tsx#L222">src/code-edit.tsx#L222</a>  <ul><p><span>HTMLPreElement</span></p>        </ul></details><details id="host$125" title="Property" ><summary><span><a href="#host$125">#</a></span>  <code><strong>host</strong></code>    </summary>  <a href=""></a>  <ul><p><a href="#CodeEditElement$31">CodeEditElement</a></p>        </ul></details><details id="hoveringMarker$64" title="Property" ><summary><span><a href="#hoveringMarker$64">#</a></span>  <code><strong>hoveringMarker</strong></code>    </summary>  <a href="src/code-edit.tsx#L227">src/code-edit.tsx#L227</a>  <ul><p><code>null</code> | <a href="#Marker$5">Marker</a></p>        </ul></details><details id="language$38" title="Property" ><summary><span><a href="#language$38">#</a></span>  <code><strong>language</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>''</code></span>  </summary>  <a href="src/code-edit.tsx#L197">src/code-edit.tsx#L197</a>  <ul><p>string</p>        </ul></details><details id="layout$57" title="Property" ><summary><span><a href="#layout$57">#</a></span>  <code><strong>layout</strong></code>    </summary>  <a href="src/code-edit.tsx#L221">src/code-edit.tsx#L221</a>  <ul><p><span>SuperImposeElement</span></p>        </ul></details><details id="lenses$65" title="Property" ><summary><span><a href="#lenses$65">#</a></span>  <code><strong>lenses</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>[]</code></span>  </summary>  <a href="src/code-edit.tsx#L230">src/code-edit.tsx#L230</a>  <ul><p><a href="#Lens$27">Lens</a>  []</p>        </ul></details><details id="markers$59" title="Property" ><summary><span><a href="#markers$59">#</a></span>  <code><strong>markers</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>[]</code></span>  </summary>  <a href="src/code-edit.tsx#L225">src/code-edit.tsx#L225</a>  <ul><p><a href="#Marker$5">Marker</a>  []</p>        </ul></details><details id="markersCss$60" title="Property" ><summary><span><a href="#markersCss$60">#</a></span>  <code><strong>markersCss</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>...</code></span>  </summary>  <a href="src/code-edit.tsx#L226">src/code-edit.tsx#L226</a>  <ul><p><details id="__type$61" title="Function" ><summary><span><a href="#__type$61">#</a></span>  <em>(selector)</em>    </summary>    <ul>    <p>    <details id="selector$63" title="Parameter" ><summary><span><a href="#selector$63">#</a></span>  <code><strong>selector</strong></code>    </summary>    <ul><p>string</p>        </ul></details>  <p><strong></strong><em>(selector)</em>  &nbsp;=&gt;  <ul>string</ul></p></p>    </ul></details></p>        </ul></details><details id="onInput$71" title="Property" ><summary><span><a href="#onInput$71">#</a></span>  <code><strong>onInput</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>...</code></span>  </summary>  <a href="src/code-edit.tsx#L241">src/code-edit.tsx#L241</a>  <ul><p><details id="__type$72" title="Function" ><summary><span><a href="#__type$72">#</a></span>  <em>()</em>    </summary>    <ul>    <p>      <p><strong></strong><em>()</em>  &nbsp;=&gt;  <ul>void</ul></p></p>    </ul></details></p>        </ul></details><details id="onScroll$74" title="Property" ><summary><span><a href="#onScroll$74">#</a></span>  <code><strong>onScroll</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>...</code></span>  </summary>  <a href="src/code-edit.tsx#L247">src/code-edit.tsx#L247</a>  <ul><p><details id="__type$75" title="Function" ><summary><span><a href="#__type$75">#</a></span>  <em>()</em>    </summary>    <ul>    <p>      <p><strong></strong><em>()</em>  &nbsp;=&gt;  <ul>void</ul></p></p>    </ul></details></p>        </ul></details><details id="onWheel$77" title="Property" ><summary><span><a href="#onWheel$77">#</a></span>  <code><strong>onWheel</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>...</code></span>  </summary>  <a href="src/code-edit.tsx#L251">src/code-edit.tsx#L251</a>  <ul><p><span>EventHandler</span>&lt;<span>SuperImposeElement</span>, <span>WheelEvent</span>&gt;</p>        </ul></details><details id="onmounted$123" title="Property" ><summary><span><a href="#onmounted$123">#</a></span>  <code><strong>onmounted</strong></code>    </summary>    <ul><p><span>EventHandler</span>&lt;<a href="#CodeEditElement$31">CodeEditElement</a>, <span>CustomEvent</span>&lt;any&gt;&gt;</p>        </ul></details><details id="onunmounted$124" title="Property" ><summary><span><a href="#onunmounted$124">#</a></span>  <code><strong>onunmounted</strong></code>    </summary>    <ul><p><span>EventHandler</span>&lt;<a href="#CodeEditElement$31">CodeEditElement</a>, <span>CustomEvent</span>&lt;any&gt;&gt;</p>        </ul></details><details id="root$66" title="Property" ><summary><span><a href="#root$66">#</a></span>  <code><strong>root</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>...</code></span>  </summary>  <a href="src/code-edit.tsx#L232">src/code-edit.tsx#L232</a>  <ul><p><span>ShadowRoot</span></p>        </ul></details><details id="syntax$55" title="Property" ><summary><span><a href="#syntax$55">#</a></span>  <code><strong>syntax</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>{}</code></span>  </summary>  <a href="src/code-edit.tsx#L218">src/code-edit.tsx#L218</a>  <ul><p><a href="#SyntaxOrImport$2">SyntaxOrImport</a></p>        </ul></details><details id="tabSize$40" title="Property" ><summary><span><a href="#tabSize$40">#</a></span>  <code><strong>tabSize</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>2</code></span>  </summary>  <a href="src/code-edit.tsx#L201">src/code-edit.tsx#L201</a>  <ul><p>number</p>        </ul></details><details id="tabStyle$41" title="Property" ><summary><span><a href="#tabStyle$41">#</a></span>  <code><strong>tabStyle</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>'spaces'</code></span>  </summary>  <a href="src/code-edit.tsx#L203">src/code-edit.tsx#L203</a>  <ul><p><code>"spaces"</code> | <code>"tabs"</code></p>        </ul></details><details id="textShadow$43" title="Property" ><summary><span><a href="#textShadow$43">#</a></span>  <code><strong>textShadow</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>false</code></span>  </summary>  <a href="src/code-edit.tsx#L207">src/code-edit.tsx#L207</a>  <ul><p>boolean</p>        </ul></details><details id="textarea$56" title="Property" ><summary><span><a href="#textarea$56">#</a></span>  <code><strong>textarea</strong></code>    </summary>  <a href="src/code-edit.tsx#L220">src/code-edit.tsx#L220</a>  <ul><p><span>TextAreaCodeElement</span></p>        </ul></details><details id="theme$39" title="Property" ><summary><span><a href="#theme$39">#</a></span>  <code><strong>theme</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>''</code></span>  </summary>  <a href="src/code-edit.tsx#L199">src/code-edit.tsx#L199</a>  <ul><p>string</p>        </ul></details><details id="updateCaret$82" title="Property" ><summary><span><a href="#updateCaret$82">#</a></span>  <code><strong>updateCaret</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>...</code></span>  </summary>  <a href="src/code-edit.tsx#L266">src/code-edit.tsx#L266</a>  <ul><p><details id="__type$83" title="Function" ><summary><span><a href="#__type$83">#</a></span>  <em>()</em>    </summary>    <ul>    <p>      <p><strong></strong><em>()</em>  &nbsp;=&gt;  <ul>void</ul></p></p>    </ul></details></p>        </ul></details><details id="value$34" title="Property" ><summary><span><a href="#value$34">#</a></span>  <code><strong>value</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>''</code></span>  </summary>  <a href="src/code-edit.tsx#L189">src/code-edit.tsx#L189</a>  <ul><p>string</p>        </ul></details><details id="scrollLeft$67" title="Accessor" ><summary><span><a href="#scrollLeft$67">#</a></span>  <code><strong>scrollLeft</strong></code>    </summary>  <a href="src/code-edit.tsx#L234">src/code-edit.tsx#L234</a>  <ul>        </ul></details><details id="scrollTop$69" title="Accessor" ><summary><span><a href="#scrollTop$69">#</a></span>  <code><strong>scrollTop</strong></code>    </summary>  <a href="src/code-edit.tsx#L237">src/code-edit.tsx#L237</a>  <ul>        </ul></details><details id="created$174" title="Method" ><summary><span><a href="#created$174">#</a></span>  <code><strong>created</strong></code><em>(ctx)</em>    </summary>  <a href=""></a>  <ul>    <p>    <details id="ctx$176" title="Parameter" ><summary><span><a href="#ctx$176">#</a></span>  <code><strong>ctx</strong></code>    </summary>    <ul><p><span>Context</span>&lt;<a href="#CodeEditElement$31">CodeEditElement</a> &amp; <span>JsxContext</span>&lt;<a href="#CodeEditElement$31">CodeEditElement</a>&gt; &amp; <span>Omit</span>&lt;{<p>    <details id="ctor$180" title="Parameter" ><summary><span><a href="#ctor$180">#</a></span>  <code><strong>ctor</strong></code>    </summary>    <ul><p><span>Class</span>&lt;<a href="#T$90">T</a>&gt;</p>        </ul></details>  <p><strong></strong>&lt;<span>T</span>&gt;<em>(ctor)</em>  &nbsp;=&gt;  <ul><span>CleanClass</span>&lt;<a href="#T$90">T</a>&gt;</ul></p>  <details id="ctx$195" title="Parameter" ><summary><span><a href="#ctx$195">#</a></span>  <code><strong>ctx</strong></code>    </summary>    <ul><p><a href="#T$105">T</a> | <span>Class</span>&lt;<a href="#T$105">T</a>&gt;</p>        </ul></details>  <p><strong></strong>&lt;<span>T</span>&gt;<em>(ctx)</em>  &nbsp;=&gt;  <ul><span>Wrapper</span>&lt;<a href="#T$105">T</a>&gt;</ul></p></p>} &amp; <span>__module</span> &amp; {<p>  <details id="Boolean$199" title="Property" ><summary><span><a href="#Boolean$199">#</a></span>  <code><strong>Boolean</strong></code>    </summary>  <a href=""></a>  <ul><p>undefined | boolean</p>        </ul></details><details id="Number$198" title="Property" ><summary><span><a href="#Number$198">#</a></span>  <code><strong>Number</strong></code>    </summary>  <a href=""></a>  <ul><p>undefined | number</p>        </ul></details><details id="String$197" title="Property" ><summary><span><a href="#String$197">#</a></span>  <code><strong>String</strong></code>    </summary>  <a href=""></a>  <ul><p>undefined | string</p>        </ul></details></p>}, <code>"transition"</code>&gt;&gt;</p>        </ul></details>  <p><strong>created</strong><em>(ctx)</em>  &nbsp;=&gt;  <ul>void</ul></p></p>    </ul></details><details id="mounted$85" title="Method" ><summary><span><a href="#mounted$85">#</a></span>  <code><strong>mounted</strong></code><em>($)</em>    </summary>  <a href="src/code-edit.tsx#L283">src/code-edit.tsx#L283</a>  <ul>    <p>    <details id="$$87" title="Parameter" ><summary><span><a href="#$$87">#</a></span>  <code><strong>$</strong></code>    </summary>    <ul><p><span>Context</span>&lt;<a href="#CodeEditElement$31">CodeEditElement</a> &amp; <span>JsxContext</span>&lt;<a href="#CodeEditElement$31">CodeEditElement</a>&gt; &amp; <span>Omit</span>&lt;{<p>    <details id="ctor$91" title="Parameter" ><summary><span><a href="#ctor$91">#</a></span>  <code><strong>ctor</strong></code>    </summary>    <ul><p><span>Class</span>&lt;<a href="#T$90">T</a>&gt;</p>        </ul></details>  <p><strong></strong>&lt;<span>T</span>&gt;<em>(ctor)</em>  &nbsp;=&gt;  <ul><span>CleanClass</span>&lt;<a href="#T$90">T</a>&gt;</ul></p>  <details id="ctx$106" title="Parameter" ><summary><span><a href="#ctx$106">#</a></span>  <code><strong>ctx</strong></code>    </summary>    <ul><p><a href="#T$105">T</a> | <span>Class</span>&lt;<a href="#T$105">T</a>&gt;</p>        </ul></details>  <p><strong></strong>&lt;<span>T</span>&gt;<em>(ctx)</em>  &nbsp;=&gt;  <ul><span>Wrapper</span>&lt;<a href="#T$105">T</a>&gt;</ul></p></p>} &amp; <span>__module</span> &amp; {<p>  <details id="Boolean$110" title="Property" ><summary><span><a href="#Boolean$110">#</a></span>  <code><strong>Boolean</strong></code>    </summary>  <a href=""></a>  <ul><p>undefined | boolean</p>        </ul></details><details id="Number$109" title="Property" ><summary><span><a href="#Number$109">#</a></span>  <code><strong>Number</strong></code>    </summary>  <a href=""></a>  <ul><p>undefined | number</p>        </ul></details><details id="String$108" title="Property" ><summary><span><a href="#String$108">#</a></span>  <code><strong>String</strong></code>    </summary>  <a href=""></a>  <ul><p>undefined | string</p>        </ul></details></p>}, <code>"transition"</code>&gt;&gt;</p>        </ul></details>  <p><strong>mounted</strong><em>($)</em>  &nbsp;=&gt;  <ul>void</ul></p></p>    </ul></details><details id="on$119" title="Method" ><summary><span><a href="#on$119">#</a></span>  <code><strong>on</strong></code><em>(name)</em>    </summary>  <a href=""></a>  <ul>    <p>    <details id="name$122" title="Parameter" ><summary><span><a href="#name$122">#</a></span>  <code><strong>name</strong></code>    </summary>    <ul><p><a href="#K$121">K</a></p>        </ul></details>  <p><strong>on</strong>&lt;<span>K</span>&gt;<em>(name)</em>  &nbsp;=&gt;  <ul><span>On</span>&lt;<span>Fn</span>&lt;[  <span>EventHandler</span>&lt;<a href="#CodeEditElement$31">CodeEditElement</a>, <span>LifecycleEvents</span> &amp; object  [<a href="#K$121">K</a>]&gt;  ], <span>Off</span>&gt;&gt;</ul></p></p>    </ul></details><details id="toJSON$200" title="Method" ><summary><span><a href="#toJSON$200">#</a></span>  <code><strong>toJSON</strong></code><em>()</em>    </summary>  <a href=""></a>  <ul>    <p>      <p><strong>toJSON</strong><em>()</em>  &nbsp;=&gt;  <ul><span>Pick</span>&lt;<a href="#CodeEditElement$31">CodeEditElement</a>, keyof     <a href="#CodeEditElement$31">CodeEditElement</a>&gt;</ul></p></p>    </ul></details></p></ul></details><details id="Lens$27" title="TypeAlias" ><summary><span><a href="#Lens$27">#</a></span>  <code><strong>Lens</strong></code>    </summary>  <a href="src/code-edit.tsx#L37">src/code-edit.tsx#L37</a>  <ul><p>{<p>  <details id="line$29" title="Property" ><summary><span><a href="#line$29">#</a></span>  <code><strong>line</strong></code>    </summary>  <a href="src/code-edit.tsx#L38">src/code-edit.tsx#L38</a>  <ul><p>number</p>        </ul></details><details id="message$30" title="Property" ><summary><span><a href="#message$30">#</a></span>  <code><strong>message</strong></code>    </summary>  <a href="src/code-edit.tsx#L39">src/code-edit.tsx#L39</a>  <ul><p>string</p>        </ul></details></p>}</p>        </ul></details><details id="Marker$5" title="TypeAlias" ><summary><span><a href="#Marker$5">#</a></span>  <code><strong>Marker</strong></code>    </summary>  <a href="src/code-edit.tsx#L23">src/code-edit.tsx#L23</a>  <ul><p>{<p>  <details id="class$11" title="Property" ><summary><span><a href="#class$11">#</a></span>  <code><strong>class</strong></code>    </summary>  <a href="src/code-edit.tsx#L28">src/code-edit.tsx#L28</a>  <ul><p>string</p>        </ul></details><details id="el$12" title="Property" ><summary><span><a href="#el$12">#</a></span>  <code><strong>el</strong></code>    </summary>  <a href="src/code-edit.tsx#L29">src/code-edit.tsx#L29</a>  <ul><p><span>HTMLSpanElement</span></p>        </ul></details><details id="index$8" title="Property" ><summary><span><a href="#index$8">#</a></span>  <code><strong>index</strong></code>    </summary>  <a href="src/code-edit.tsx#L25">src/code-edit.tsx#L25</a>  <ul><p>number</p>        </ul></details><details id="key$7" title="Property" ><summary><span><a href="#key$7">#</a></span>  <code><strong>key</strong></code>    </summary>  <a href="src/code-edit.tsx#L24">src/code-edit.tsx#L24</a>  <ul><p>string</p>        </ul></details><details id="oncreate$14" title="Property" ><summary><span><a href="#oncreate$14">#</a></span>  <code><strong>oncreate</strong></code>    </summary>  <a href="src/code-edit.tsx#L31">src/code-edit.tsx#L31</a>  <ul><p><details id="__type$15" title="Function" ><summary><span><a href="#__type$15">#</a></span>  <em>(el)</em>    </summary>    <ul>    <p>    <details id="el$17" title="Parameter" ><summary><span><a href="#el$17">#</a></span>  <code><strong>el</strong></code>    </summary>    <ul><p><span>HTMLSpanElement</span></p>        </ul></details>  <p><strong></strong><em>(el)</em>  &nbsp;=&gt;  <ul>void</ul></p></p>    </ul></details></p>        </ul></details><details id="onenter$18" title="Property" ><summary><span><a href="#onenter$18">#</a></span>  <code><strong>onenter</strong></code>    </summary>  <a href="src/code-edit.tsx#L32">src/code-edit.tsx#L32</a>  <ul><p><details id="__type$19" title="Function" ><summary><span><a href="#__type$19">#</a></span>  <em>(el)</em>    </summary>    <ul>    <p>    <details id="el$21" title="Parameter" ><summary><span><a href="#el$21">#</a></span>  <code><strong>el</strong></code>    </summary>    <ul><p><span>HTMLSpanElement</span></p>        </ul></details>  <p><strong></strong><em>(el)</em>  &nbsp;=&gt;  <ul>void</ul></p></p>    </ul></details></p>        </ul></details><details id="onleave$22" title="Property" ><summary><span><a href="#onleave$22">#</a></span>  <code><strong>onleave</strong></code>    </summary>  <a href="src/code-edit.tsx#L33">src/code-edit.tsx#L33</a>  <ul><p><details id="__type$23" title="Function" ><summary><span><a href="#__type$23">#</a></span>  <em>(el)</em>    </summary>    <ul>    <p>    <details id="el$25" title="Parameter" ><summary><span><a href="#el$25">#</a></span>  <code><strong>el</strong></code>    </summary>    <ul><p><span>HTMLSpanElement</span></p>        </ul></details>  <p><strong></strong><em>(el)</em>  &nbsp;=&gt;  <ul>void</ul></p></p>    </ul></details></p>        </ul></details><details id="onwheel$26" title="Property" ><summary><span><a href="#onwheel$26">#</a></span>  <code><strong>onwheel</strong></code>    </summary>  <a href="src/code-edit.tsx#L34">src/code-edit.tsx#L34</a>  <ul><p><span>$.EventHandler</span>&lt;any, <span>WheelEvent</span>&gt;</p>        </ul></details><details id="rect$13" title="Property" ><summary><span><a href="#rect$13">#</a></span>  <code><strong>rect</strong></code>    </summary>  <a href="src/code-edit.tsx#L30">src/code-edit.tsx#L30</a>  <ul><p><span>DOMRect</span></p>        </ul></details><details id="size$9" title="Property" ><summary><span><a href="#size$9">#</a></span>  <code><strong>size</strong></code>    </summary>  <a href="src/code-edit.tsx#L26">src/code-edit.tsx#L26</a>  <ul><p>number</p>        </ul></details><details id="source$10" title="Property" ><summary><span><a href="#source$10">#</a></span>  <code><strong>source</strong></code>    </summary>  <a href="src/code-edit.tsx#L27">src/code-edit.tsx#L27</a>  <ul><p>string</p>        </ul></details></p>}</p>        </ul></details><details id="SyntaxOrImport$2" title="TypeAlias" ><summary><span><a href="#SyntaxOrImport$2">#</a></span>  <code><strong>SyntaxOrImport</strong></code>    </summary>  <a href=""></a>  <ul><p><span>SyntaxDefinition</span> | <span>Promise</span>&lt;{<p>  <details id="default$4" title="Property" ><summary><span><a href="#default$4">#</a></span>  <code><strong>default</strong></code>    </summary>  <a href=""></a>  <ul><p><span>SyntaxDefinition</span></p>        </ul></details></p>}&gt;</p>        </ul></details><details id="languages$1" title="Variable" ><summary><span><a href="#languages$1">#</a></span>  <code><strong>languages</strong></code>    </summary>  <a href=""></a>  <ul><p><span>Record</span>&lt;string, <a href="#SyntaxOrImport$2">SyntaxOrImport</a>&gt;</p>        </ul></details></p>

## Credits

- [code-syntax](https://npmjs.org/package/code-syntax) by [stagas](https://github.com/stagas) &ndash; Code syntax highlight Web Component
- [get-element-offset](https://npmjs.org/package/get-element-offset) by [stagas](https://github.com/stagas) &ndash; Get accurate DOM element offset.
- [relative-mouse](https://npmjs.org/package/relative-mouse) by [stagas](https://github.com/stagas) &ndash; Get mouse position relative to a DOM element.
- [sigl](https://npmjs.org/package/sigl) by [stagas](https://github.com/stagas) &ndash; Web framework
- [super-impose](https://npmjs.org/package/super-impose) by [stagas](https://github.com/stagas) &ndash; Web Component that super imposes one child over another to the same scroll position
- [textarea-code](https://npmjs.org/package/textarea-code) by [stagas](https://github.com/stagas) &ndash; Web Component that extends a textarea element with code editor behavior.

## Contributing

[Fork](https://github.com/stagas/code-edit/fork) or [edit](https://github.dev/stagas/code-edit) and submit a PR.

All contributions are welcome!

## License

<a href="LICENSE">MIT</a> &copy; 2022 [stagas](https://github.com/stagas)
